import numpy as np
import matplotlib.pyplot as plt

Nx=70
xmax=10
dx=xmax/Nx
x=np.linspace(0,xmax,Nx+1)

Nt=100
tmax=1
dt=tmax/Nt

# tabulka pro reseni
u=np.zeros((Nt+1,Nx+1))

# pocatecni podminka
u[0,:]=np.exp(-2*(x-xmax/2)**2)

# reseni difuzni rovnice
for k in range(0,Nt):
    for j in range(1,Nx):
        u[k+1,j]=u[k,j]+dt/dx**2*(u[k,j-1]-2*u[k,j]+u[k,j+1])

# vyhodnoceni kriteria stability
print(dt,dx**2/2)

# graf reseni
for k in range(0,Nt+1,Nt//10):
    plt.subplot(11,1,k//10+1)
    plt.plot(x,u[k,:],'b-')
 
#plt.imshow(u,aspect='auto',origin='lower', \
# extent=[0.0,xmax,0.0,tmax],cmap='inferno',vmin=0,vmax=1)    
    
plt.show()